import { Promise } from "./promise";

function resolve(thenable) {
  return new Promise(function(resolve, reject) {
    if (typeof thenable === "object" && thenable !== null) {
      var then = thenable.then;
      if ((then !== undefined) && (typeof then === "function")) {
        return then.apply(thenable, [resolve, reject]);
      }
    }
    return resolve(thenable);
  }, function () {
    if ((thenable !== undefined) && (thenable.cancel !== undefined)) {
      thenable.cancel();
    }
  });
}

export { resolve };
