import { Promise } from "./promise";

function promiseSetTimeout(millisecond, should_reject, message) {
  var timeout_id;

  function resolver(resolve, reject) {
    timeout_id = setTimeout(function () {
      if (should_reject) {
        reject(message);
      } else {
        resolve(message);
      }
    }, millisecond);
  }
  function canceller() {
    clearTimeout(timeout_id);
  }
  return new Promise(resolver, canceller);
}

function delay(millisecond, message) {
  return promiseSetTimeout(millisecond, false, message);
}

function timeout(millisecond) {
  return promiseSetTimeout(millisecond, true,
                           "Timed out after " + millisecond + " ms");
}

Promise.prototype.delay = function(millisecond) {
  return this.then(function (fulfillmentValue) {
    return delay(millisecond, fulfillmentValue);
  });
};

export { delay, timeout };
