/*global RSVP*/

var Queue;

if (typeof RSVP !== 'undefined') {
  // Test the browser build
  Queue = RSVP.Queue;
} else {
  // Test the Node build
  RSVP = require('../dist/commonjs/main');
  Queue = require('../dist/commonjs/main').Queue;
  Promise = require('../dist/commonjs/main').Promise;
  assert = require('./vendor/assert');
}

if (typeof window === 'undefined' && typeof global !== 'undefined') {
  window = global;
}

var adapter = {};

adapter.fulfilled = function(value) {
  return new Queue()
    .push(function () {
      return value;
    });
};

adapter.rejected = function(error) {
  return new Queue()
    .push(function () {
      return RSVP.reject(error);
    });
};

adapter.pending = function () {
  var pending = {},
    promise = new Promise(function(resolve, reject) {
        pending.fulfill = resolve;
        pending.reject = reject;
      });

  pending.promise = new Queue()
    .push(function () {
      return promise;
    });

  return pending;
};

module.exports = global.adapter = adapter;
